window.onerror = function(err) {
        log('window.onerror: ' + err);
}

function setupWebViewJavascriptBridge(callback) {
    if (window.DFWebViewJSBridge) {alert("DFWebViewJSBridge存在"); return callback(DFWebViewJSBridge); }
    if (window.DFWVJBCallbacks) { return window.DFWVJBCallbacks.push(callback); }
    window.DFWVJBCallbacks = [callback];
    var WVJBIframe = document.createElement('iframe');
    WVJBIframe.style.display = 'none';
    WVJBIframe.src = 'dfwvjbscheme://__BRIDGE_LOADED__';
    document.documentElement.appendChild(WVJBIframe);
    setTimeout(function () {document.documentElement.removeChild(WVJBIframe)}, 0);
}

setupWebViewJavascriptBridge(function (bridge) {

    var uniqueId = 1;
    function log(message, data) {
        var log = document.getElementById('log');
        var el = document.createElement('div');
        el.className = 'logLine';
        el.innerHTML = uniqueId++ + '. ' + message + ':<br/>' + JSON.stringify(data);
        if (log.children.length) {
            log.insertBefore(el, log.children[0]);
        } else {
            log.appendChild(el);
        }
    }

    // 检测字符串是否为空
    function isStrNull(str) {
        if(str == "" || str == undefined || str == null || (str.length > 0 && str.trim().length == 0)) {
            return false;
        } else {
             return true;
        }
    }

    // 直接在这里注册函数来的实在一些
    bridge.registerHandler('DFBridge.js.testJS', function(data, responseCallback) {
        log('原生调JS函数: testJS, 传递数据', data);
        var responseData = { 'dfzq':'Hello Michael!' };
        log('JS收到数据后的响应', responseData);
        responseCallback(responseData);
        var ret = responseData['dfzq'];
        DFBridge.native.dfzq_michael(function(ret) {
            alert('testJS: ' + ret);
        });
    });

    bridge.registerHandler('DFBridge.js.msg_alert', function(data, responseCallback) {
        log('原生调JS函数: msg_alert, 传递数据', data);
        var responseData = { 'dfzq':'Hello Michael!' };
        responseCallback(responseData);
        var msg = data['msg'];
        alert(msg);
    });

    bridge.registerHandler('DFBridge.js.addfunc', function(data, responseCallback) {
        var func_name = data["func_name"];
        var responseData = { 'dfzq': 'JS函数'+ func_name + '注册成功!' };
        responseCallback(responseData);
        DFBridge.js.register(func_name,function(ret) {
            var msg = ret['dfzq'];
            alert(msg);
        });
    });

    // DFBridge.js.register();
    window.DFBridge = {

        js: {
            register: function(func_name,callBack) {
                var responseData = { 'dfzq': 'JS函数'+ func_name + '调用成功!' };
                callBack(responseData);
                bridge.registerHandler(func_name, function(data, responseCallback) {
                    responseCallback(responseData);
                });
            },
        },

        native: {

            dfzq_michael: function(data,callBack) {
                callBack(data);
            },

            /**
             * 验证SDK-License
             *
             * @param  {function} callBack 回调函数
             */
            verify_sdk_licesnse: function(callBack) {
                bridge.callHandler('DFBridge.native.verify_sdk_licesnse', function(responseData) {
                    console.log('JS调原生函数: verify_sdk_licesnse, JS接收到数据: ' + responseData);
                    var msg = responseData['msg'];
                    callBack(msg);
                });
            },

            /**
             * 初始化SZCA-SDK
             *
             * @param  {string}   account   初始化账号(用户身份证号码)
             * @param  {string}   name      用户姓名
             * @param  {string}   keytype   密钥类型 : RSA/SM2
             * @param  {string}   pwd       密码
             * @param  {function} callBack  回调函数
             */
            init_szca_sdk: function(account,name,keytype,pwd,callBack) {
                var params = {'account':account, 'name':name, 'keytype':keytype, 'pwd':pwd};
                bridge.callHandler('DFBridge.native.init_szca_sdk', params, function(responseData) {
                    console.log('JS调原生函数: init_szca_sdk, JS接收到数据: ' + responseData);
                    callBack(responseData);
                });
            },

            /**
             * 身份认证, 并申请授权证书
             *
             * @param  {function} callBack 回调函数
             */
            apply_auth_cer: function(callBack) {
                bridge.callHandler('DFBridge.native.apply_auth_cer', function(responseData) {
                    console.log('JS调原生函数: apply_auth_cer, JS接收到数据: ' + responseData);
                    callBack(responseData);
                });
            },

            /**
             * 签署文件的接口
             *
             * @param  {string}   fileId   待签署文件的id
             * @param  {string}   hash     待签名文件数据的hash，base64编码
             * @param  {function} callBack 请求后的回调函数
             */
            signed_file: function(fileId,hash,hashTsa,callBack) {
                var params = {'fileId':fileId, 'hash':hash, 'hashTsa':hashTsa};
                bridge.callHandler('DFBridge.native.signed_file', params, function(responseData) {
                    console.log('JS调原生函数: signed_file, JS接收到数据: ' + responseData);
                    callBack(responseData);
                });
            },

            /**
             * 证书遗失补办
             *
             * @param  {function} callBack 回调函数
             */
            reissue_cer: function(callBack) {
                bridge.callHandler('DFBridge.native.reissue_cer', function(responseData) {
                    console.log('JS调原生函数: reissue_cer, JS接收到数据: ' + responseData);
                    callBack(responseData);
                });
            },

            /**
             * 重置Pin码
             *
             * @param  {string}   account  授权账号
             * @param  {function} callBack 回调函数
             */
            reset_pin: function(account,callBack) {
                var params = {'account': account};
                bridge.callHandler('DFBridge.native.reset_pin', params, function(responseData) {
                    console.log("JS调原生函数: reset_pin, JS接收到数据:", responseData);
                    callBack(responseData);
                });
            },

            /**
             * 证书申请或遗失补办请求
             *
             * @param  {Object}   params   请求体参数，JSON对象
             * @param  {function} callBack 回调函数
             */
            request_cer:function(params,callBack) {
                bridge.callHandler('DFBridge.native.request_cer', params, function(responseData) {
                    console.log("JS调原生函数: request_cer, JS接收到数据:", responseData);
                    callBack(responseData);
                });
            },

            /**
             * 获取深圳CA证书信息: certDn(主题), certSn(序列号)
             *
             * @param  {function} callBack 回调函数
             */
            get_cerinfo:function(callBack) {
                bridge.callHandler('DFBridge.native.get_cerinfo', function(responseData) {
                    console.log("JS调原生函数: get_cerinfo, JS接收到数据:", responseData);
                    callBack(responseData);
                });
            },

            /**
             * 显示签署成功后的PDF文件
             *
             * @param  {function} callBack 回调函数
             */
            show_signed_pdf:function(callBack) {
                bridge.callHandler('DFBridge.native.show_signed_pdf', function(responseData) {
                    console.log("JS调原生函数: show_signed_pdf, JS接收到数据:", responseData);
                    callBack(responseData);
                });
            },

            /**
             * 清除证书信息,调用此函数后SDK需要重新初始化
             *
             * @param  {function} callBack 回调函数
             */
            clean_cerinfo:function(callBack) {
                bridge.callHandler('DFBridge.native.clean_cerinfo', function(responseData) {
                    console.log("JS调原生函数: clean_webcache, JS接收到数据:", responseData);
                    callBack(responseData);
                });
            },

            /**
             * 清除WebView缓存数据
             *
             * @param  {function} callBack 回调函数
             */
            clean_webcache:function(callBack) {
                bridge.callHandler('DFBridge.native.clean_webcache', function(responseData) {
                    console.log("JS调原生函数: clean_webcache, JS接收到数据:", responseData);
                    callBack(responseData);
                });
            },

            /**
             * 打开指定的URL地址(必须有效)
             *
             * @param  {Object}   url   URL地址
             * @param  {function} callBack 回调函数
             */
            open_url:function(url,title,callBack) {
                var params = {'url':url,'title':title};
                bridge.callHandler('DFBridge.native.open_url', params, function(responseData) {
                    console.log("JS调原生函数: request_cer, JS接收到数据:", responseData);
                    callBack(responseData);
                });
            },

            /**
             * 关闭WebView
             */
            close_webview:function() {
                bridge.callHandler('DFBridge.native.close_webview', null);
            },

            /**
             * 返回到上一级页面
             * @param  {bool}     toRootPage 是否返回到根页面
             */
            goback:function(toRootPage) {
                var params = {'toRootPage':toRootPage};
                bridge.callHandler('DFBridge.native.goback', params, null);
            },

            /**
             * 设置是否返回到根页面
             * @param  {bool}     toRootPage 是否返回到根页面
             */
            goback_rootpage:function(toRootPage) {
                var params = {'toRootPage':toRootPage};
                bridge.callHandler('DFBridge.native.goback_rootpage', params, null);
            },

            /**
             * 获取渠道id
             * @param  {function} callBack 回调函数
             */
            get_channel_id:function(callBack) {
                bridge.callHandler('DFBridge.native.get_channel_id', function(responseData) {
                    callBack(responseData);
                });
            },

            /**
             * 导航栏右边事件定制
             * @param  {Object}   params   参数
             * @param  {function} callBack 回调函数
             */
            nav_right_event:function(params,callBack) {
                bridge.callHandler('DFBridge.native.nav_right_event', params, function(responseData) {
                    console.log("JS调原生函数: nav_right_event, JS接收到数据:", responseData);
                    callBack(responseData);
                });
            },

            /**
             * 原生函数调用
             * @param  {String}   funcname 函数功能号
             * @param  {Object}   params   参数
             * @param  {function} callBack 回调函数
             */
            invoke:function(funcname,params,callBack) {
                // var func_name = params["func_name"];
                bridge.callHandler('DFBridge.native.' + funcname, params, function(responseData) {
                    callBack(responseData);
                });
            },
        },
    };
    if (onDFBridgeReady) { onDFBridgeReady(); }
});
