$(function() {
	$.getConfig("config/home.ini", function(data) {
		if(data.errCode == 0) {
			var home_config = data.result;
			console.log(home_config);
			if(home_config.setting.enablesetting.toLowerCase() == "yes") {
				$("#shortcut").empty();
				setShortcut(home_config.shortcut);
				setNewsSc(home_config.focussc);
				setEssence(home_config.essence);
				setFocus(home_config.focus);
				setEvents(home_config.events);
			}
		} else {
			console.log(data.result);
		}
	});

	// 快捷方式配置获取
	function setShortcut(shortcuts) {
		if(!shortcuts) return;
		var number = shortcuts.scnum || 0;
		var suffix = shortcuts.iconsuffix || "png";
		var changeSecNum = parseInt((number-1)/8) + 1;
		for (var i = 0; i < changeSecNum; i++) {
			var secHtml = '';
			secHtml += '<div class="shortcut-arr">';
			for(var j = 0; j < 8; j++) {
				if(i*8+j >= number) break;
				secHtml += '<div class="sc">';
				var iconUrl = "icon/" + shortcuts.shortcut[i*8+j].scicon;
				if(iconUrl.length > 3 && iconUrl.slice(-3, iconUrl.length) != "png" && iconUrl.slice(-3, iconUrl.length) != "jpg" && iconUrl.slice(-3, iconUrl.length) != "gif" && iconUrl.slice(-3, iconUrl.length) != "ico") {
					iconUrl = iconUrl + "." + suffix;
				}
				secHtml +=   '<img src="' + iconUrl + '"><br>';
				secHtml +=   '<span>' + shortcuts.shortcut[i*8+j].scname + '</span>';
				secHtml += '</div>';
			}
			secHtml +=   '<div class="clear"></div>';
			secHtml += '</div>';

			$("#shortcut").append(secHtml);
		}

		$(".sc").each(function(index, el) {
			$(el).on('touchend', function(event) {
				toCallJavaUrl(shortcuts.shortcut[index].scurlmode, shortcuts.shortcut[index].scname, shortcuts.shortcut[index].scurl);
			});
		});
		
		if(changeSecNum>1) {
			$(".shortcut-arr").each(function(index, el) {
				if(index != 0) {
					$(el).hide();
				}
			});
			$("#shortcut").css("padding-bottom", "0");

			var cgHtml = "";
			cgHtml += '<div id="sc_change">';
			for(var i = 0; i < changeSecNum; i++) {
				cgHtml += '<div class="change-icon"></div>';
			}
			cgHtml += '</div>';

			var nowPos = 0;

			$("#shortcut").append(cgHtml);
			$(".change-icon").eq(nowPos).css("background-color", "rgb(0, 160, 233)");

			$("#shortcut").on('swipeleft', function(event) {
				$(".change-icon").css("background-color", "rgb(136, 138, 140)");
				$(".shortcut-arr").eq(nowPos).hide();
				if(nowPos == 0) {
					nowPos = changeSecNum-1;
				}
				else {
					nowPos = nowPos - 1;
				}
				$(".change-icon").eq(nowPos).css("background-color", "rgb(0, 160, 233)");
				$(".shortcut-arr").eq(nowPos).show();
			});
			$("#shortcut").on('swiperight', function(event) {
				$(".change-icon").css("background-color", "rgb(136, 138, 140)");
				$(".shortcut-arr").eq(nowPos).hide();
				if(nowPos == changeSecNum-1) {
					nowPos = 0;
				} else {
					nowPos = nowPos + 1;
				}
				$(".change-icon").eq(nowPos).css("background-color", "rgb(0, 160, 233)");
				$(".shortcut-arr").eq(nowPos).show();
			});
		}
	}

	// 新闻快捷入口
	function setNewsSc(newssc) {
		if(!newssc) return;
		if(newssc.newsnum >= 2) {
			$(".focussc-item").each(function(index, el) {
				$(el).find('.title span').text(newssc.focussc[index].newstitle);
				$(el).find('.content').text(newssc.focussc[index].newscontent);

				$(el).on('touchend', function(event) {
					toCallJavaUrl(newssc.focussc[index].newsurlmode, newssc.focussc[index].newstitle, newssc.focussc[index].newsurl);
				});
			});
		}
	}

	// 精华
	function setEssence(essence) {
		if(!essence) return;
		$("#essence > div.title span.more").on("touchend", function(event) {
			toCallJavaUrl(essence.essenceurlmode, "精华", essence.essenceurl);
		});
		if(essence.essnum>=4) {
			var imgSuffix = essence.imgsuffix || "png";
			$(".essence-item").each(function(index, el) {
				var imgSrc = essence.essence[index].essimage;
				if(imgSrc.slice(-3, imgSrc.length) != "png" && imgSrc.slice(-3, imgSrc.length) != "jpg" && imgSrc.slice(-3, imgSrc.length) != "gif" && imgSrc.slice(-3, imgSrc.length) != "ico") {
					imgSrc = "images/" + imgSrc + "." + imgSuffix;
				} else {
					imgSrc = "images/" + imgSrc;
				}
				$(el).find('img').prop("src", imgSrc);
				$(el).find('.title').text(essence.essence[index].esstitle);
				$(el).find('.content').text(essence.essence[index].esscontent);
			});
		}
	}

	// 焦点
	function setFocus(focus) {
		if(!focus) return;
		$("#focus > div.title span.more").on("touchend", function(event) {
			toCallJavaUrl(focus.focusurlmode, "焦点", focus.focusurl);
		});
	}

	// 事件
	function setEvents(events) {
		if(!essence) return;
		$("#events > div.title span.more").on("touchend", function(event) {
			toCallJavaUrl(events.eventsurlmode, "事件", events.eventsurl);
		});
	}

	init();
	//页面初始化
	function init(){
		//精华数据请求
		queryData(jhdata,'mzx_jh',['201','1','20151119','1','4']);
		var topicid = new Array();//保存每个条目的跳转id
		function jhdata(data){
			var getdata = JSON.parse(data).ResultSets[0].Content;
			//Info_Type 精华类型
			//info_date 精华时间
			//modtime   最新一条资讯时间
			var html = '';
			for(var i=0;i<getdata.length;i++){
				topicid.push(getdata[i]);
			}

			//响应点击事件
			$('.essence-item').each(function(index, el) {
				$(el).on("touchend", function(event) {
					var url = 'http://page.tdx.com.cn:7615/site/MobInfo/html/jhsj.html?' + 'funid='+topicid[index][0]+'&time='+topicid[index][2].replace(/\s/,'+');
					toCallJavaUrl("NetURL", $(el).find("span.title").text(), url);
				});
			});		
		}

		//请求焦点数据
		var topicid = new Array();//保存每个条目的跳转id
		queryData(jdData, "mzx_yw",['119','','1','4']);
		function jdData(data){
			alert(data);
			alert(JSON.stringify(JSON.parse(data).ResultSets[0].Content));
			data = JSON.parse(data).ResultSets[0].Content;
			var datareg = '';
			for(var i=0;i<data.length;i++){
	            data[i][0] = data[i][0].substring(0,35);//限制字数
	            //对日期进行处理
	            if(data[i][1].split(' ')[0] != today){
	                datareg = data[i][1].substring(5,10);
	            }
	            else{
	                datareg = data[i][1].match(/\d+:\d+/);
	            }

	            topicid.push(data[i][4]);
	            if(data[i][2] == null){data[i][2] = '';}
	            
                var noimg = '';
                noimg+='<div class="focus-item">';
				noimg+='	<span class="content">'+data[i][0]+'</span>';
				noimg+='	<span class="time">'+datareg+'</span>';
				noimg+='</div>';
                $('#focus').append(noimg);
	        };

	        //对单个条目的点击事件
	        $('.focus-item').unbind('click').click(function() {
	            var clickindex = $(this).index();
	            var myurl = "cjzx.html"+"?"+"clickindex="+topicid[clickindex]+'&param=101';
	            
	            //获取标题和图片并发送
	            var clickTitle = $(this).find('p').eq(0).text();
	            var clickimg = '';
	            if($(this).prop('class') == 'hasimg'){
	                clickimg = $(this).find('img').prop('src');
	            }
	            var clickSubtitle = $(this).find('p').eq(1).text() || '';
	            var clickTime = $(this).find('p').eq(2).text();
	            pagejump(myurl,'',clickTitle,clickimg,clickSubtitle,clickTime);
	        }); 
		}

		//请求事件界面数据
		var item = new Array();
		var sjsj = new Array();
		var stocknum = new Array();
		var setcodenum = new Array();
		var dataStore = new Array();//保存数据，在点击的时候进行传送
		queryData(sjdata,"mzx_sjqd",['601','0','1','4']);
		function sjdata(data){
			var getdata = JSON.parse(data).ResultSets[0].Content;
            for(var i=0;i<getdata.length;i++){
				stocknum[i] = getdata[i][2].split(',');
				setcodenum[i] = getdata[i][4].split(',');
				sjsj[i] = new incidentdata();
				sjsj[i].time = getdata[i][1];
				sjsj[i].name = getdata[i][0];
				sjsj[i].sjid = getdata[i][3];
				for(var j=0;j<stocknum[i].length;j++){
					if(stocknum[i][j].length != 6){stocknum[i].splice(j,1);}
				}
				queryhq(backhq,stocknum[i],i,setcodenum[i]);
			} 
		}

		function backhq(data,param){
			var hqdata = JSON.parse(data).List;
			for(var i=0;i<hqdata.length;i++){
				sjsj[param].stockzf.push(parseFloat(queryZf(hqdata[i][3],hqdata[i][4])));
				if(sjsj[param].maxzf < keeptwo(sjsj[param].stockzf[i])){
					sjsj[param].maxzf = keeptwo(sjsj[param].stockzf[i]);
				}
				sjsj[param].zf+=parseFloat(sjsj[param].stockzf[i]);
			}
			sjsj[param].zf = keeptwo(sjsj[param].zf/stocknum[param].length);
			dataStore.push(sjsj[param]);
			item.push(sjsj[param].sjid);

			//对时间进行控制，当天的显示时分，历史的都显示日月
			var datareg;
			if(sjsj[param].time.split(' ')[0] != today){datareg = sjsj[param].time.substring(5,10);}
        	else{ datareg = sjsj[param].time.match(/\d+:\d+/); }

			//添加html
			var html='';
			html+='<div class="events-item">'
			html+='	<div class="title">'+sjsj[param].name+'</div>'
			html+='	<div class="content">'+sjsj[param].zf+'%<span style="color: green;">-1.81%</span> 龙头表现 <span style="color: red;">'+sjsj[param].maxzf+'%</span> <span class="time">'+datareg+'</span></div>'
			html+='</div>'
			$('#events').append(html);

			//红涨绿跌
			$(".content ").each(function() {
				var text = $(this).children('span').eq(0).text();
				$(this).children('span').eq(0).css('color',queryColor(text));
				text = $(this).children('span').eq(1).text();
				$(this).children('span').eq(1).css('color',queryColor(text));
			})

			//点击事件
	        $('.events-item .content').unbind('click').on('click',function() {
	            var clickindex = $(this).index();
	            var myurl = "tcglgyl.html"+"?clickindex="+dataStore[clickindex].sjid+'&zfDay='+dataStore[clickindex].zf+'&param=602';
	            pagejump(myurl);
	        })	
		}

		function incidentdata() {
			this.stockzf = new Array();
			this.zf = 0;
			this.time = '';
			this.maxzf = 0;
			this.name = '';
			this.sjid = 0;
		}
	}

	// 检查TdxWebCall存在状态
	function checkTdxJava() {
		if(window.tdx_java && window.tdx_java.TdxWebCall) {
			return true;
		}
		else {
			// // alert("异步跳转函数不存在!");
			return false;
		}
	}

	// 页面切换
	function toCallJavaUrl(mode, title, url) {
		if(checkTdxJava()) {
			if(mode == "Java") {
				var tdxFuncParam = {
					"OpenID": url
				}
				// alert("Proc: " + "TdxWebCall" + "\nParams: " + JSON.stringify(["tdxOpenNativeModule", tdxFuncParam, "", ""]));
				window.tdx_java.TdxWebCall("tdxOpenNativeModule", JSON.stringify(tdxFuncParam), "", "");
			}
			else if(mode == "NetURL") {
				var tdxFuncParam = {
					"OpenName": title,
					"OpenType": "native",
					"OpenUrl": url,
					"OpenParam": {"UrlType": "Remote"},
					"ShareInfo": {"Time": new Date().getTime().toString()}
				}
				// alert("Proc: " + "TdxWebCall" + "\nParams: " + JSON.stringify(["tdxOpenUrl", tdxFuncParam, "", ""]));
				window.tdx_java.TdxWebCall("tdxOpenUrl", JSON.stringify(tdxFuncParam), "", "");
			}
			else if(mode == "LocalURL") {
				var tdxFuncParam = {
					"OpenName": title,
					"OpenType": "native",
					"OpenUrl": url,
					"OpenParam": {"UrlType": "Absolute"},
					"ShareInfo": {"Time": new Date().getTime().toString()}
				}
				// alert("Proc: " + "TdxWebCall" + "\nParams: " + JSON.stringify(["tdxOpenUrl", tdxFuncParam, "", ""]));
				window.tdx_java.TdxWebCall("tdxOpenUrl", JSON.stringify(tdxFuncParam), "", "");
			}
		}
		else {
			if(mode == "Java") {
				var tdxFuncParam = {
					"OpenID": url
				}
				// alert("Proc: " + "TdxWebCall" + "\nParams: " + JSON.stringify(["WebCall", JSON.stringify(tdxFuncParam), "tdxOpenNativeModule", "", undefined]));
				// window.tdx_java.TdxWebCall("tdxOpenNativeModule", JSON.stringify(tdxFuncParam), "", "");
				IOS_Bridge.call("WebCall", JSON.stringify(tdxFuncParam), "tdxOpenNativeModule", "", undefined);
			}
			else if(mode == "NetURL") {
				var tdxFuncParam = {
					"OpenName": title,
					"OpenType": "native",
					"OpenUrl": url,
					"OpenParam": {"UrlType": "Remote"},
					"ShareInfo": {"Time": new Date().getTime().toString()}
				}
				// alert("Proc: " + "TdxWebCall" + "\nParams: " + JSON.stringify(["WebCall", JSON.stringify(tdxFuncParam), "tdxOpenUrl", "", undefined]));
				IOS_Bridge.call("WebCall", JSON.stringify(tdxFuncParam), "tdxOpenUrl", "", undefined);
			}
			else if(mode == "LocalURL") {
				var tdxFuncParam = {
					"OpenName": title,
					"OpenType": "native",
					"OpenUrl": url,
					"OpenParam": {"UrlType": "Absolute"},
					"ShareInfo": {"Time": new Date().getTime().toString()}
				}
				// alert("Proc: " + "TdxWebCall" + "\nParams: " + JSON.stringify(["WebCall", JSON.stringify(tdxFuncParam), "tdxOpenUrl", "", undefined]));
				IOS_Bridge.call("WebCall", JSON.stringify(tdxFuncParam), "tdxOpenUrl", "", undefined);
			}
		}
	}
});

/*
 * IOS函数桥接
 */
var IOS_Bridge = {

 	callbacksCount: 1,
 	callbacks: {},

 	resultForCallback: function resultForCallback(callbackId, resultArray) {
 		try {
 			var callback = IOS_Bridge.callbacks[callbackId];
 			if (!callback) {
 				return;
 			}
 			callback.apply(null, resultArray);
 		} catch (e) {
 			// alert(e);
 		}
 	},

    /*
     * functionName: 调用函数名称
     * args:json 格式参数
     * callback 回调函数，可有可无
    */
    call: function call(functionName, args, funcID, frameID, callback) {

    	var hasCallback = callback && typeof callback == "function";
    	var callbackId = hasCallback ? IOS_Bridge.callbacksCount++ : 0;

    	if (hasCallback) {
    		IOS_Bridge.callbacks[callbackId] = callback;
    	}
    	var iframe = document.createElement("IFRAME");
    	iframe.setAttribute("src", "tdx-frame:" + functionName + ";;" + frameID + ";;" + funcID + ";;" + args + ";;" + callback);

    	document.documentElement.appendChild(iframe);
    	iframe.parentNode.removeChild(iframe);
    	iframe = null;

    }
 };