﻿//适当性管理
TradeManage.order = [
    {
        listen: function (param) {  //交易协议发送监听
            //场内交易委托功能号监听
            if (param["funcid"] == "202" || param["funcid"] == "3000") {    //功能号为202或3000
                //逻辑解释：场内交易大部分委托功能号都是一样的，所以不仅要按功能号判断，而且还需要按文件名进行筛选
                switch (GetPagePathInfo()["formid"]) {
                    case "cnjjrg":  //场内基金认购
                    case "cnjjsg":  //场内基金申购
                    case "dzjycjqrmr":  //大宗交易成交确认买入
                    case "dzjydjmr":    //大宗交易定价买入
                    case "dzjyphmr":    //大宗交易盘后买入
                    case "dzjyyxmr":    //大宗交易意向买入
                    case "etfsg":   //ETF申购
                    case "etfwsxjrg":   //ETF网上现金认购
                    case "etfwxgprg":   //ETF网下股票认购
                    case "etfwxxjrg":   //ETF网下现金认购
                    case "kjetfsg": //跨境ETF申购
                    case "ksetfswsg":   //跨市ETF实物申购
                    case "ksetfwxgprg": //跨市ETF网下股票认购
                    case "hbjjrg":  //货币基金认购
                    case "hbjjsg":  //货币基金申购
                    case "lofrg":   //LOF认购
                    case "lofsg":   //LOF申购
                    case "gfzrcjqrmr":  //股份转让成交确认买入
                    case "gfzrdjmr":    //股份转让定价买入
                    case "gfzrhbcjqrmr":    //股份转让互报成交确认买入
                    case "gfzrxjmr":    //股份转让限价买入
                    case "xjcpdj":  //现金产品登记
                    case "yysb":    //要约申报
                    case "zqywrzhg":    //债券业务融资回购
                    case "zqywzyck":    //债券业务质押出库
                    case "zyck":    //质押出库
                        param["trade-type"] = "cnjy";   //存储交易类型标志(场内交易)
                        return true;
                    default:
                        break;
                }
            }

            //协议签署委托功能号监听
            if (param["funcid"] == "170") { //功能号为170
                //逻辑解释：功能号170无特殊性，且被很多其他业务使用，因此不能作为协议签署的特定功能号，需要按文件名进行筛选
                switch (GetPagePathInfo()["formid"]) {
                    case "xyqs":
                        param["trade-type"] = "xyqs";   //存储交易类型标志(协议签署)
                        return true;
                    default:
                        break;
                }
            }

            //场外交易委托功能号监听
            if (param["funcid"] == "2100" || param["funcid"] == "2600") {   //功能号为2100或2600，字段F1223为1
                //逻辑解释：场外交易所有的认购和申购委托参数F1223一般都设为1，赎回无F1223，if语句的作用是为了跳过所有赎回功能
                if (param["ix"].Get("F1223") == "1") {
                    param["trade-type"] = "cwjy";   //存储交易类型标志(场外交易)
                    return true;
                }
            }
            if (param["funcid"] == "2104" || param["funcid"] == "2130") {    //功能号为2104或2130
                //逻辑解释：基金转换、基金定投的委托功能号
                param["trade-type"] = "cwjy";   //存储交易类型标志(场外交易)
                return true;
            }

            //场外开户委托功能号监听
            if (param["funcid"] == "2118" || param["funcid"] == "2600") {   //功能号为2118或2600，字段F113为1
                //逻辑解释：基金、OTC、券商理财、银行理财开户委托参数F113等于1时，表示是开户委托协议
                if (param["ix"].Get("F113") == "1") {
                    param["trade-type"] = "cwkh";   //存储交易类型标志(场外开户)
                    return true;
                }
            }
        },
        respond: function (param) {  //交易协议发送拦截
            ShowLoading(2);
            var json = { "F1217": "SDX.CHECK_RISK_PRODUCTCODE," };  //传递给硬代码的交易参数
            switch (param["trade-type"]) {
                case "cnjy":    //场内交易分支添加参数
                    json["F125"] = param["ix"].Get("F125"); //账号类别(从委托协议的入参中获取)
                    json["F123"] = param["ix"].Get("F123"); //股东代码(从委托协议的入参中获取)
                    if (typeof (param["ix"].Get("F603")) == "string") {
                        json["F130"] = param["ix"].Get("F603"); //买卖标志(从委托协议的入参中获取)
                    }
                    else {
                        json["F130"] = param["ix"].Get("F130"); //买卖标志(从委托协议的入参中获取)
                    }
                    json["F391"] = GetMobFormDes(GetSendData(2)[0]);    //产品代码(从代码输入框中获取)
                    break;
                case "xyqs":    //协议签署分支添加参数
                    json["F1217"] = "SDX.CHECK_RISK_PRODUCTCODE.QSXY,"; //备注
                    json["F125"] = param["ix"].Get("F125"); //账号类别(从委托协议的入参中获取)
                    json["F123"] = param["ix"].Get("F123"); //股东代码(从委托协议的入参中获取)
                    json["F1227"] = json["F123"] + "@" + json["F125"] + "@" + jsonCache["F149_0"] + "@" + jsonCache["F1223"];   //参数(股东代码+账号类别+业务类型+检查风险标志)(变量jsonCache为当前签署的列表行数据)
                    break;
                case "cwjy":    //场外交易分支添加参数
                    json["F125"] = "";
                    json["F123"] = "";
                    json["F391"] = GetMobFormDes(GetSendData(3)[0]);    //产品代码(从代码输入框中获取)
                    json["F393"] = param["ix"].Get("F426"); //产品公司代码(从委托协议的入参中获取)

                    //如果是基金转换类业务
                    if (typeof (GetSendData_KZCX) == "function") {
                        json["F391"] = GetMobFormDes(GetSendData_KZCX(3)[0]);   //产品代码(从转入代码输入框中获取)
                        if (typeof (KZXXCache) == "object" && KZXXCache.length > 2) {
                            if (typeof (KZXXCache[2]["F426"]) == "string") {
                                json["F393"] = KZXXCache[2]["F426"];    //产品公司代码(从GetSendData_KZCX函数中的case 2查询的返回数据中获取)
                            }
                        }
                    }
                    break;
                case "cwkh":    //场外开户分支添加参数
                    json["F125"] = "";
                    json["F123"] = "";
                    json["F393"] = param["ix"].Get("F426"); //产品公司代码(从委托协议的入参中获取)
                    break;
                default:
                    break;
            }

            //调用硬代码适当性流程
            CallAppFunc(json, "WebCall:tdxSdxCheckUp", function (data) {
                switch (typeof (data)) {
                    case "object":
                        if (typeof (data[0]) == "object") {
                            if (Number(data[0][0]) == 0) {
                                ShowLoading(1, "正在提交...");
                                var remark = TradeManage.order[0].param["ix"].Get("F1217");
                                if (typeof (remark) == "string" && remark != "") {
                                    //如果原委托参数里面已经包含F1217字段，则需要修改F1217入参，直接在字符串“SDX.ORDER,”添加原F1217参数即可
                                    TradeManage.order[0].param["ix"].Set("F1217", "SDX.ORDER," + remark);   //备注(委托协议新增参数)
                                }
                                else {
                                    TradeManage.order[0].param["ix"].Set("F1217", "SDX.ORDER,");    //备注(委托协议新增参数)
                                }
                                var jsonData = FormatMobListData(data);
                                if (typeof (jsonData) == "object" && jsonData.length > 2) {
                                    TradeManage.order[0].param["ix"].Set("F1284", jsonData[2]["F1284"]);    //信息标题(委托协议新增参数)
                                }
                                TradeManage.next(); //页面流程放行(继续发送委托协议)
                            }
                        }
                        else {
                            GlobalAlert({ "content": JSON.stringify(data) });
                        }
                        break;
                    case "string":
                        GlobalAlert({ "content": data });
                        break;
                    default:
                        GlobalAlert({ "content": "返回数据格式有误，无法显示返回结果！" });
                        break;
                }
            });
        }
    }
];