﻿//交易发送协议(港股-公开招股申购)
GetSendData = function(n, json) {
    var funcid = "";
    var ix = new IXContent();
    switch (n) {
        case 0: //返回表单多选下拉框所需内容(申购类型字段、申购类型内容)
            return ["F130", [json["sglx"][1], json["sglx"][0]]];
        case 1: //返回IPO信息查询所需字段名(证券代码、证券名称)
            return ["F140", "F141"];
        case 2: //IPO信息查询
            funcid = "1158"; //功能号
            ix.Set("F110", json["wtfs"]); //委托方式
            ix.Set("F140", json["F140"]); //证券代码
            break;
        case 3: //IPO申请股数与金额展示所需字段名(申请股数、申请时应缴款项)
            return ["F192", "F322"];
        case 4: //IPO申请费用展示所需字段名(申购类型、融资比例、风险说明、融资利率、融券日期、现金申请费用、融资申请费用)
            return ["F130", "F1186", "F182", "F1198", "F375", "F1183", "F1192"];
        case 5: //IPO扩展信息展示字段名(融资比例、融资总数、申购金额、融资利率、融资利息、申请费用、应缴款项、申报上限)
            return ["RZBL", "RZZS", "SGJE", "LL", "LX", "SQFY", "YJKX", "SBSX"];
        case 6: //返回表单提交所需字段名(证券代码、证券名称、买卖标志、申请股数、融资总数、融资比例、申请费用)
            return ["F140", "F141", "F130", "F192", "RZZS", "RZBL", "SQFY"];
        case 7: //表单提交(现金申购)
            funcid = "208";
            ix.Set("F110", json["wtfs"]); //委托方式
            ix.Set("F130", "2"); //买卖标志
            ix.Set("F140", json["F140"]); //证券代码
            ix.Set("F144", json["F192"]); //委托数量
            ix.Set("F212", json["F1183"]); //申请费用
            ix.Set("F234", "C"); //类型
            break;
        case 8: //表单提交(融资申购)
            funcid = "208";
            ix.Set("F110", json["wtfs"]); //委托方式
            ix.Set("F130", "1"); //买卖标志
            ix.Set("F140", json["F140"]); //证券代码
            ix.Set("F144", json["F192"]); //委托数量
            ix.Set("F1168", json["RZZS"]); //融资总数
            ix.Set("F1186", parseInt(json["F1186"] / 100)); //融资比例
            ix.Set("F212", json["F1192"]); //申请费用
            ix.Set("F234", "P"); //类型
            break;
        default:
            break;
    }
    return [funcid, ix];
}

// 表单初始化
SetBDCSHLoadForm = function() {
    try {
        var RZBL = ipoStockData[2]["F1186"];
        ipoStockData[2]["F1186"] = (Number(RZBL) * 100).toString();
    } catch (err) {}
    var rzlv= ipoStockData[2]["F1184"];//1184融资利率做可融标志，为0则不可融
    if(rzlv==0||rzlv==""){//若融资利率为0，则只返回现金申购
        SetMobFormDes("F130", GetSubscribe()[1]);
    }
}

dfhkRespondTj = function() {
    try {
        if (GetMobFormDes("F130") == "融资申购" && GetMobFormDes("RZZS") <= "0.00") {
            alert("融资金额不足");
        } else {
            RespondTj();
        }
    } catch (err) {

    }
}