define(["jquery", "selfcnt", "common"], function (require, exports, module) {
    var common = require("common")
    var selfcnt = require("selfcnt")
    var curIndex = '0'
    var hasQuery = [-1, -1,-1,-1]
    var showcur = {"0":{"chart":"chggt","table":"tbggt","body":"byggt"},
                    "1":{"chart":"chhgt","table":"tbhgt","body":"byhgt"},
                    "2":{"chart":"chssgt","table":"tbssgt","body":"byssgt"},
                    "3":{"chart":"chsgt","table":"tbsgt","body":"bysgt"}}
    var tcfg = [
        {"class": "txtcenter", "width": 60, "field": "sT001"},
        {"class": "txtcenter", "width": "30%", "field": "rT009", "fmtFn": common.fmtTwo, "type": "zdf"},
        {"class": "txtcenter", "width": "30%", "field": "T010", "fmtFn": common.fmtTwo},
        {"class": "txtcenter", "width": "40%", "field": "rT003", "fmtFn": common.fmtTwo, "type": "zdf"}
    ]
    var scroll = new common.txScroll({}, {"id": "selcontent", "upCall": query})
    scroll._init()
    var cahceDate = {"0": {}, "1": {},"2":{},"3":{}}
    $(".nav2 ul li").bind("click", function () {
        if ($(this).hasClass("active"))
            return
        else {
            $(".nav2 ul li").removeClass("active")
            $(this).addClass("active")
            curIndex = $(this).attr("value")
        }
        showTab()
        if (hasQuery[parseInt(curIndex)] == 1)
            return
        scroll.IScroll.refresh();
        scroll.IScroll.scrollTo(0, 0);
        query()
    })
    function showTab() {
        for(var key in showcur){
            if(key == curIndex){
                $("#"+showcur[key]["chart"]).css("display", "")
                $("#"+showcur[key]["table"]).css("display", "")
            }else{
                $("#"+showcur[key]["chart"]).css("display", "none")
                $("#"+showcur[key]["table"]).css("display", "none")
            }
        }
    }
    query()
    function query() {
        selfcnt.send("phsj_gg_hgt", [curIndex, "0", '', ''], function (data) {
            data = selfcnt.seftFmtResult(data)
            if (data.ErrorCode == 0 && data.tables.length == 2) {
                var ntype = data.tables[1].rows[0]["ntype"]
                if (ntype != curIndex)
                    return
                hasQuery[parseInt(ntype)] = 1
                var sid=showcur[ntype]["chart"]
                var tableid=showcur[ntype]["body"]
                var arrRows = [], trows = data.tables[0].rows;
                var nlen = trows.length - 1
                var arrBody = []
                $.each(trows, function (i, row) {
                    if (i < 60) {
                        var str = ''
                        if (i != nlen) {
                            str = '<tr value="' + trows[i + 1]["sT001"] + '">'
                        }else{
                            str = '<tr value="">'
                        }
                        $.each(tcfg, function (i, tr) {
                            if(i == 0){
                                str += ('<td jyr="'+row[tr["field"]]+'" valign="' + (tr["valign"] || "top") + '" width="' + (tr["width"] || "100%") + '" class="' + tr["class"] + '">' + common.formatDate(row[tr["field"]]).substring(5) + '</td>')
                            }
                            else if (tr["type"] == "zdf") {
                                var cls = ''
                                if (common.fmtFlt(row[tr["field"]]) > 0)
                                    cls = 'hprice'
                                else if (common.fmtFlt(row[tr["field"]]) < 0) {
                                    cls = 'lprice'
                                }
                                str += ('<td valign="' + (tr["valign"] || "top") + '" width="' + (tr["width"] || "100%") + '" class="' + tr["class"] + " " + cls + '">' + (tr["fmtFn"] || common.etyStr)(row[tr["field"]], row) + '</td>')
                            } else {
                                str += ('<td valign="' + (tr["valign"] || "top") + '" width="' + (tr["width"] || "100%") + '" class="' + tr["class"] + '">' + (tr["fmtFn"] || common.etyStr)(row[tr["field"]], row) + '</td>')
                            }
                        })
                        str += "</tr>"
                        arrBody.push(str)
                        arrBody.push(getsub(row["sT001"] + curIndex,curIndex))
                        arrRows.push(row)
                    }
                })
                require.async(["highchart", "chartcolor"], function () {
                    var chartcolor = require("chartcolor")
                    var dch = {"cate": [], "yxas": []}
                    $.each(arrRows, function (i, trow) {
                        dch["cate"].push(common.formatDate(trow["sT001"]))
                        dch["yxas"].push(common.fmtFlt(trow["rT009"]))
                    })
                    var odChar = $.extend(true, {}, chartcolor[common.bgcolor] || {}, common.defaultChart, {
                        chart: {
                            type: 'spline',
                            spacingBottom: 10
                        },
                        yAxis: {
                            labels: {
                                "format": "{value}亿"
                            }
                        },
                        legend: {
                            enabled: false
                        },
                        xAxis: {
                            categories: dch["cate"]
                        },
                        series: [{type: 'spline', "name": "资金流入(亿)", data: dch["yxas"]}],
                    })
                    $("#" + sid).highcharts(odChar)
                })

                var otrs = $(arrBody.join(""))
                otrs.appendTo($("#" + tableid))
                scroll.upAction()
                var trs = $.grep(otrs, function (tr) {
                    return (typeof $(tr).attr("value") !== 'undefined')
                })
                $(trs).bind("click", function (e) {

                    var prejyr = $(this).attr("value")
                    var jyr = $(this).children("td:eq(0)").attr("jyr")
                    var s = $("#" + jyr + curIndex).attr("attr")
                    if (s == "open") {
                        $("#" + jyr + curIndex).attr("attr", "close")
                        $("#" + jyr + curIndex).css("display", "none")
                        scroll.upAction()
                    }
                    else {
                        if (cahceDate[curIndex][jyr]) {
                            var preid = $("#" + tableid).attr("curid")
                            $("#" + preid).attr("attr", "close")
                            $("#" + preid).css("display", "none")
                            $("#" + jyr + curIndex).attr("attr", "open")
                            $("#" + tableid).attr("curid", jyr + curIndex);

                            subTable(jyr, cahceDate[curIndex][jyr])
                            return
                        }
                        selfcnt.send("phsj_gg_hgt", ["4", curIndex, jyr, prejyr], function (sdata) {
                            sdata = selfcnt.seftFmtResult(sdata)
                            if (sdata.ErrorCode == 0 && sdata.tables.length == 2) {
                                var sjyr = sdata.tables[1].rows[0]["sjyr"]
                                var stype = sdata.tables[1].rows[0]["nsel"]
                                cahceDate[stype][sjyr] = sdata.tables[0].rows
                                if (stype != curIndex)
                                    return
                                var preid = $("#" + tableid).attr("curid")
                                $("#" + sjyr + curIndex).attr("attr", "open")
                                $("#" + tableid).attr("curid", sjyr + curIndex);
                                $("#" + preid).attr("attr", "close")
                                $("#" + preid).css("display", "none")
                                subTable(sjyr, sdata.tables[0].rows)
                            }
                        })
                    }
                })
            }
        },{"reqtype":"cwserv"})
    }

    function subTable(sjyr, data) {
        $("#" + sjyr + curIndex).css("display", "")
        var otbody = $("#" + sjyr + curIndex).find("tbody")

        otbody.empty()
        if (data.length == 0) {
            $('<tr><td colspan="4"><div class="tipinfo" style="display:block">暂无十大成交活跃股数据!!!</div></td></tr>').appendTo(otbody)
            return
        }
        var subtr;
        if(curIndex==0||curIndex==2){
            subtr = $(common.getTableBody(data, [{
                "class": "txtcenter",
                "width": 105,
                "field": "name",
                "fmtFn": common.getsixcode
            },
                {"class": "txtcenter", "width": "20%", "field": "zdf", "type": "zdf", "fmtFn": common.fmtTwo},
                {"class": "txtcenter", "width": "40%", "field": "jme", "fmtFn": common.fmtTwo},
                {"class": "txtcenter", "width": "40%", "field": "cje", "fmtFn": common.fmtTwo}
            ]))
        }else{
            subtr = $(common.getTableBody(data, [{
                "class": "txtcenter",
                "width": 105,
                "field": "name",
                "fmtFn": common.getsixcode
            },
                {"class": "txtcenter", "width": "22%", "field": "zdf", "type": "zdf", "fmtFn": common.fmtTwo},
                {"class": "txtcenter", "width": "37%", "field": "jme", "fmtFn": common.fmtTwo},
                {"class": "txtcenter", "width": "41%", "field": "cje", "fmtFn": common.fmtTwo}
            ]))
        }

        subtr.appendTo(otbody)
        //common.bindGp(function () {
            subtr.unbind('click').bind('click', function () {
                selfcnt.goMulGpDetail(subtr,$(this))
                //selfcnt.goGpDetail($(this).attr("gp").split(";"))
            })
        //})

        scroll.upAction()
    }

    function getsub(sid,cix) {
        var str = ""
        if(cix=="0" || cix=="2"){
            str += '<tr style="display:none" id="' + sid + '"><td class="ctd" colspan=4>'
            str += '<table  class="subwebtable" style="width: 100%;table-layout: fixed;" cellpadding="0" cellspacing="0"> <thead><tr> <th style="text-align:center" width="105">证券名称</th>'
            str += '<th style="text-align:center" width="20%">涨跌</th> <th style="text-align:center" width="40%">净买额(万港元)</th>'
            str += '<th style="text-align:center" width="40%">成交额(万港元)</th> </tr>'
            str += '</thead><tbody></tbody></table></td></tr>'
        }else{
            str += '<tr style="display:none" id="' + sid + '"><td class="ctd" colspan=4>'
            str += '<table  class="subwebtable" style="width: 100%;table-layout: fixed;" cellpadding="0" cellspacing="0"> <thead><tr> <th style="text-align:center" width="105">证券名称</th>'
            str += '<th style="text-align:center" width="22%">涨跌</th> <th style="text-align:center" width="37%">净买额(万)</th>'
            str += '<th style="text-align:center" width="41%">成交额(万)</th> </tr>'
            str += '</thead><tbody></tbody></table></td></tr>'
        }

        return str;
    }
})
